﻿using RimWorld;
using RimWorld.Planet;
using System.Collections.Generic;
using Verse;
using Verse.AI;
using Verse.Sound;
using VFECore.Abilities;
using Ability = VFECore.Abilities.Ability;
using VanillaPsycastsExpanded;

namespace Stunskip
{
	public class AbilityExtension_CastStunskip : AbilityExtension_AbilityMod
	{
		public override void Cast(GlobalTargetInfo[] targets, Ability ability)
        {
			base.Cast(targets, ability);
			var pawnsToApply = new List<GlobalTargetInfo>();
			foreach (Pawn pawn in ability.pawn.MapHeld.mapPawns.AllPawnsSpawned)
			{
				if (pawn == ability.pawn) continue;
				if (pawn.Downed) continue;
				{
					ability.ApplyHediff(pawn);
					pawn.stances.stunner.StunFor(ability.def.durationTime, null, false);

					//var appliedHediff = pawn.health.hediffSet.GetFirstHediffOfDef(StunskipDefOf.VPE_PerceptionFreeze);
					//pawn.health.AddHediff(appliedHediff);
				}
			}

		}
	}
}
