﻿using RimWorld;
using RimWorld.Planet;
using System.Collections.Generic;
using Verse;
using Verse.AI;
using Verse.Sound;
using VFECore.Abilities;
using Ability = VFECore.Abilities.Ability;
using VanillaPsycastsExpanded;

namespace Stunskip
{
    public class AbilityExtension_StunskipCooldown : AbilityExtension_AbilityMod
    { 
        public List<string> Stunskip_Abilities = new List<string>
          {
                "VPE_stunskip_i",
                "VPE_stunskip_ii",
                "VPE_stunskip_restrain_i",
                "VPE_stunskip_restrain_ii",
                "VPE_stunskip_teleport_i",
                "VPE_stunskip_teleport_ii",
                "VPE_stunskip_strike_i",
                "VPE_stunskip_strike_ii"
         };
        public override void Cast(GlobalTargetInfo[] targets, Ability ability)
        {
            foreach (var VPE_stunskip_i in ability.Comp.LearnedAbilities)
            {
                if (Stunskip_Abilities.Contains(VPE_stunskip_i.def.defName))
                {
                    VPE_stunskip_i.cooldown = Find.TickManager.TicksGame + 600;
                }
            }

            foreach (var VPE_stunskip_ii in ability.Comp.LearnedAbilities)
            {
                if (Stunskip_Abilities.Contains(VPE_stunskip_ii.def.defName))
                {
                    VPE_stunskip_ii.cooldown = Find.TickManager.TicksGame + 600;
                }
            }

            foreach (var VPE_stunskip_restrain_i in ability.Comp.LearnedAbilities)
            {
                if (Stunskip_Abilities.Contains(VPE_stunskip_restrain_i.def.defName))
                {
                    VPE_stunskip_restrain_i.cooldown = Find.TickManager.TicksGame + 600;
                }
            }

            foreach (var VPE_stunskip_restrain_ii in ability.Comp.LearnedAbilities)
            {
                if (Stunskip_Abilities.Contains(VPE_stunskip_restrain_ii.def.defName))
                {
                    VPE_stunskip_restrain_ii.cooldown = Find.TickManager.TicksGame + 600;
                }
            }

            foreach (var VPE_stunskip_teleport_i in ability.Comp.LearnedAbilities)
            {
                if (Stunskip_Abilities.Contains(VPE_stunskip_teleport_i.def.defName))
                {
                    VPE_stunskip_teleport_i.cooldown = Find.TickManager.TicksGame + 600;
                }
            }

            foreach (var VPE_stunskip_teleport_ii in ability.Comp.LearnedAbilities)
            {
                if (Stunskip_Abilities.Contains(VPE_stunskip_teleport_ii.def.defName))
                {
                    VPE_stunskip_teleport_ii.cooldown = Find.TickManager.TicksGame + 600;
                }
            }

            foreach (var VPE_stunskip_strike_i in ability.Comp.LearnedAbilities)
            {
                if (Stunskip_Abilities.Contains(VPE_stunskip_strike_i.def.defName))
                {
                    VPE_stunskip_strike_i.cooldown = Find.TickManager.TicksGame + VPE_stunskip_strike_i.GetCooldownForPawn();
                }
            }

            foreach (var VPE_stunskip_strike_ii in ability.Comp.LearnedAbilities)
            {
                if (Stunskip_Abilities.Contains(VPE_stunskip_strike_ii.def.defName))
                {
                    VPE_stunskip_strike_ii.cooldown = Find.TickManager.TicksGame + 600;
                }
            }
        }

    }

}
